import javax.swing.*;
import java.awt.event.*;
import java.awt.*;


/**
 * A generic About dialog on swing toolkit.
 *
 * @author Alberto M. B. Simes
 */
public class About extends JDialog implements WindowListener, ActionListener {

    /**
     * The constructor and, the only method really used. Calling this
     * constructor, an about window will be shown with an OK button.
     *
     * @param tit The title of the application
     * @param description The description of the application
     */
    public About(String tit,String description) {
	JLabel title;
	JButton button;
	JPanel panel,spanel;

	// Set the window title
	this.setTitle("About: " + tit);

	// Create a panel to insert components
	panel = new JPanel(new GridLayout(4,1));
	panel.setBorder(new javax.swing.border.EmptyBorder(4,10,10,4));

	// Create the title component
	title = new JLabel("About: " + tit);
	title.setFont(new Font("SansSerif",Font.ITALIC|Font.BOLD,20));
	title.setForeground(new Color(0,0,0));
	panel.add(title);
	
	// the description component
	panel.add(new JLabel(description));

	// the copyright
	panel.add(new JLabel("(C)2001-2002 Alberto Manuel B. Simes"));

	// and the 'ok' button
	spanel = new JPanel();
	button = new JButton("OK");
	button.addActionListener(this);
	spanel.add(button);
	panel.add(spanel);

	this.getContentPane().add(panel);
	this.pack();
	this.show();
	this.addWindowListener(this);
    }

    public void windowActivated  (WindowEvent e) {}
    public void windowClosed     (WindowEvent e) {}
    public void windowClosing    (WindowEvent e) { this.dispose(); }
    public void windowDeactivated(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowIconified  (WindowEvent e) {}
    public void windowOpened     (WindowEvent e) {}

    /**
     * The method to manage interface action events.
     *
     * @param e The action event
     */
    public void actionPerformed(ActionEvent e) {
	if (e.getActionCommand().equals("OK")) {
	    this.dispose();
	}
    }

}
