import org.jdom.Element;
import org.jdom.Attribute;
import org.jdom.DataConversionException;
import java.util.*;
import java.awt.*;

/**
 * A dot in the canvas. Active, or not.
 */
public class CanvasDot extends Point implements XML {
    private boolean isActive;
    
//    public void setLocation(Point pt) {
//	super.setLocation(pt.getX(), pt.getY());
//    }

    public Element toXML() {
	Element dot = new Element("dot");
	dot.setAttribute(new Attribute("x", new java.lang.Double(this.getX()).toString()));
	dot.setAttribute(new Attribute("y", new java.lang.Double(this.getY()).toString()));
	return dot;
    }


    public CanvasDot(Element el) {
	int xx = 0, yy = 0;
	Iterator it = el.getAttributes().iterator();
	while(it.hasNext()) {
	    Attribute attr = (Attribute)it.next();
	    if (attr.getName().equals("x")) {
		try {
		    xx = (int)attr.getFloatValue();
		} catch (DataConversionException e) {
		    // RAISE ANOTHER EXCEPTION
		}
	    } else if (attr.getName().equals("y")) {
		try {
		    yy = (int)attr.getFloatValue();
		} catch (DataConversionException e) {
		    // RAISE THE OTHER EXCEPTION
		}
	    } else {
		// RAISE EXCEPTION
	    }
	}
	setLocation(xx,yy);
	setActive(false);
    }

    public CanvasDot(Point pt) {
	super(pt);
	setActive(false);
    }

    public CanvasDot(int x,int y) {
	super(x,y);
	setActive(false);
    }
    
    public CanvasDot(int x, int y, boolean b) {
	super(x,y);
	setActive(b);
    }

    public CanvasDot(Point pt, boolean b) {
	super(pt);
	setActive(b);
    }

    public void setActive(boolean b) {
	isActive = b;
    }
    public boolean isActive() {
	return isActive;
    }
}
