import org.jdom.Element;
import org.jdom.CDATA;
import java.awt.*;
import java.util.*;

public class GeographicElement implements XML {

    private Layer  type;
    private String name;
    private String description;
    private Vector elements;

    public Element toXML() {
	Element ge = new Element("element");
	
	Element e_name = new Element("name");
	e_name.addContent(name);

	Element e_description = new Element("description");
	e_description.addContent(description);

	ge.addContent(e_name);
	ge.addContent(e_description);

	Enumeration elems = elements.elements();
	while (elems.hasMoreElements()) {
	    GraphicElement graphic_elem = (GraphicElement)elems.nextElement();
	    ge.addContent(graphic_elem.toXML());
	}
	return ge;
    }

    public void show(Graphics g, boolean z) {
	Enumeration elems = elements.elements();
	while(elems.hasMoreElements()) {
	    GraphicElement ge = (GraphicElement)elems.nextElement();
	    ge.show(g,z);
	}
    }

    public void setDescription(String description) {
	this.description = new String(description);
    }

    public GeographicElement(Layer t, Element el) {
	Iterator it = el.getChildren().iterator();
	this.elements = new Vector();
	this.type = t;
	while(it.hasNext()) {
	    Element elem = (Element)it.next();
	    if (elem.getName().equals("name")) {
		this.name = new String(elem.getText());
	    } else if (elem.getName().equals("description")) {
		this.description = new String(elem.getText());
	    } else {
		GraphicElement ge;
		if (elem.getName().equals("area")) {
		    ge = new GraphicPolygon(elem);
		} else {
		    ge = null;
		    // Raise exception
		}
		ge.setActive(false);
		elements.add(ge);

	    }
	}
    }

    public GeographicElement(Layer t, String title) {
	this.elements = new Vector();
	this.name = new String(title);
	this.type = t;
    }

    public String toString() {
	return name;
    }

    public void add(GraphicElement ge) {
	elements.add(ge);
    }

}
